; ===============================================
; Freya dummy @shell Rev 0.8
; ===============================================

		.186

METHOD_COUNT	equ	((il_method_end - il_method_start) / 4)

SRAM_SEG	equ	1000h

IFNDEF NO_IL
OSWORK_SIZE	equ	(3800h / 16)	; sizeof(SRAMWork) == 0x36F2 (OS Ver1.0.0)
ELSE
OSWORK_SIZE	equ	0
ENDIF ;NO_IL

;MAX_FILES	equ	16
;SIZE_OF_IOB	equ	12

MAXPATHLEN	equ	64

SHELL_IL	struc
il_link_pos	dd	?
il_n_methods	dw	?
fp_get_info	dd	?
fp_exec		dd	?
SHELL_IL	ends

ProcContext	struc
pc_id		db	4 dup(?)
pc_pid		dw	?
pc_ppid		dw	?
pc_pcbid	dw	?
pc_ppcbid	dw	?
pc_ilib		dd	?
pc_proc		dd	?
pc_cwfs		dd	?
pc_currentdir	db	MAXPATHLEN dup (?)
;pc_n_iob	dw	?
;pc_used_iob	dw	?
;pc_iob		db	MAX_FILES * SIZE_OF_IOB dup (?)
pc_argv		dw	?
pc_resource	dd	?
pc_heap		dw	?
ProcContext	ends

farptr		struc
@off		dw	?
@seg		dw	?
farptr		ends

_TEXT		SEGMENT BYTE PUBLIC 'CODE'
_TEXT		ENDS
_DATA		SEGMENT PARA PUBLIC 'DATA'
dseg_start:
_DATA		ENDS
_BSS		SEGMENT PARA PUBLIC 'BSS'
bss_start:
_BSS		ENDS
_HEAP		segment para public 'BSS'
heap_start:
_HEAP		ends

DGROUP		GROUP   _DATA, _BSS, _HEAP

     		ASSUME  CS:_TEXT, DS:DGROUP, ES:DGROUP

		extern	_main :near

_TEXT		SEGMENT BYTE PUBLIC 'CODE'

IFNDEF NO_IL

il_shell_table	label	near
		dd	0
		dw	METHOD_COUNT
il_method_start:
		dw	offset _get_info, 0
		dw	offset _exec, 0
il_method_end:

info_className	db	"shell", 0
info_name	db	"system shell indirect", 0
info_version	db	"0.81", 0
info_description db	"Ged shell 0.81", 0

shell_info	dw	offset info_className
		dw	offset info_name
		dw	offset info_version
		dw	offset info_description
		dw	0
;------------------------------------------------
;  ILinfo far *(far *_get_info)();
_get_info	proc	far C
		mov	ax, offset shell_info
		mov	dx, cs
		ret
_get_info	endp

ENDIF ;NO_IL

_exec		proc	far C
		push	ds		; OS's ds

; calcurate initialized data size
		mov	cx, offset DGROUP:bss_start
		shr	cx, 1		; word alignmented

; copy initialized data into user ds
		mov	ax, cs
		add	ax, seg dseg_start
		mov	ds, ax
		mov	ax, SRAM_SEG + OSWORK_SIZE
		mov	es, ax
		mov	si, offset dseg_start
		mov	di, si
	rep	movsw

; clear bss
		mov	cx, offset DGROUP:heap_start
		push	cx
		mov	di, offset DGROUP:bss_start
		sub	cx, di
		shr	cx, 1
		xor	ax, ax
	rep	stosw

IFNDEF NO_IL
; copy ProcContext
		mov	ax, SRAM_SEG
		mov	ds, ax
		xor	si, si
		mov	di, offset dseg_start
		mov	cx, type ProcContext
	rep	movsb
ENDIF ;NO_IL
		push	es
		pop	ds

		pop	es:[__heap]
		pop	__os_ds

		mov	ax, cs
		mov	__resource.@seg, ax
		mov	ax, seg _BSS
		shl	ax, 4
		mov	__resource.@off, ax

		mov	__pc, offset DGROUP:__proc_context
		mov	__description.@off, offset info_description
		mov	__description.@seg, cs

		int 3
		jmp	_main

_exec		endp

		public	_reboot
_reboot		proc	
		jmp	0FFFFh:0
_reboot		endp

_TEXT		ENDS

_DATA		SEGMENT

		public	__pc, __heap, __resource, __description
__proc_context:
__id		db	'TCC', 0
__pid		dw	?
__ppid		dw	?
__pcbid		dw	?
__ppcbid	dw	?
__ilib		dd	?
__proc		dd	?
__cwfs		dd	?
__currentdir	db	MAXPATHLEN dup (?)
;__n_iob	dw	?
;__used_iob	dw	?
;__iob		db	MAX_FILES * SIZE_OF_IOB dup (?)
__argv		dw	?
__resource	dd	?
__heap		dw	?

__pc		dw	?
__os_ds		dw	?
__description	dd	?
_DATA		ENDS

		end
