; ===============================================
; character code map
; ===============================================

		.186

		include std.inc
		include bios.inc

;ROTATE		equ	TRUE

FONT_X		equ	5
FONT_Y		equ	1
FONT_CY		equ	12
 
CODE_X		equ	22
CODE_Y		equ	1

ZOOM_X		equ	23
ZOOM_Y		equ	3

TEXT_Y		equ	FONT_Y + FONT_CY + 1

		.model small
		.code

char_map	proc	C public uses SI DI
		local	fontbuff[40]:byte
		push	ds
		clr	ax
		mov	ds, ax
		mov	es, ax

		mov	bx, 1
		mov	cx, 0357h
		bios	PALETTE_SET_COLOR

		mov	si, 8140h
		clr	di		; DI : text x
char_map0:
;		clr	bx
;		mov	cx, 32 + 8
;		bios	SYS_ALLOC_IRAM
;		mov	[fontbuff], ax
char_map1:
		mov	cx, si
		movlh	bx, FONT_X, 0
		clr	dx
		push	cx
.repeat
		movlh	cx, 1, NUM_HEXA
		bios	TEXT_PUT_NUMERIC
		inc	bl
		inc	dx
.until dx >= 16
		pop	cx
		mov	bh, FONT_Y
.repeat
		push	cx
		mov	bl, 0
		mov	dx, cx
		movlh	cx, 4, NUM_HEXA
		bios	TEXT_PUT_NUMERIC
		add	bl, al
		mov	cx, ':'
		bios	TEXT_PUT_CHAR
		pop	cx

		mov	bl, FONT_X
  .repeat
		bios	TEXT_PUT_CHAR
		inc	cx
		inc	bl
  .until bl >= FONT_X + 16
		inc	bh
;		tst	cl
;  .if zero?
;		mov	cl, 40h
;  .endif
.until bh >= FONT_Y + FONT_CY

		bios1	CURSOR_DISPLAY, TRUE

		movlh	bx, FONT_X, FONT_Y

		mov	dx, si  ; code
char_map2:
		push	bx
		movlh	cx, 1, 1
		bios	CURSOR_SET_LOCATION

		movlh	bx, CODE_X, CODE_Y
		movlh	cx, 4, NUM_HEXA
		bios	TEXT_PUT_NUMERIC

		pushm	<dx, si, di>
		mov	bx, 7
		bios	FONT_SET_COLOR
		lea	di, fontbuff
		call	char_zoom
		mov	bx, 3
		bios	FONT_SET_COLOR
		popm	<di, si, dx>

		pop	bx

		bios	KEY_WAIT
.if ax == KEY_START
;		mov	bx, [fontbuff]
;		bios	SYS_FREE_IRAM
		jmp	char_map9
.endif
.if ax == KEY_A
		push	bx
		mov	bx, di
		inc	di
		mov	cx, dx
		jmp	put_text
.endif
.if ax == KEY_B
		tst	di
  .if !zero?
		dec	di
		push	bx
		mov	bx, di
		mov	cx, ' '
put_text:
		mov	bh, TEXT_Y
		bios	TEXT_PUT_CHAR
		pop	bx
  .endif
		jmp	char_map2
.endif
.if ax == KEY_DOWN2
		add	si, 0100h
  .if si == 0100h
		mov	si, 8140h
  .elseif si == 0A040h
		mov	si, 0E040h
  .elseif si == 0FD40h
		clr	si
  .endif
		jmp	char_map1
.endif
.if ax == KEY_UP2
		sub	si, 0100h
  .if carry?
		mov	si, 0FC40h
  .elseif si < 8140h
		clr	si
  .elseif si == 0DF40h
		mov	si, 09F40h
  .endif
		jmp	char_map1
.endif
.if ax == KEY_RIGHT1
		inc	bl
		inc	dx
  .if bl >= FONT_X + 16
		mov	bl, FONT_X
		sub	dx, 16
  .endif
.elseif ax == KEY_LEFT1
		dec	bl
		dec	dx
  .if bl < FONT_X
		mov	bl, FONT_X + 15
		add	dx, 16
  .endif
.elseif ax == KEY_DOWN1
		inc	bh
		add	dx, 16
  .if bh >= FONT_Y + FONT_CY
		mov	bh, FONT_Y
		sub	dx, FONT_CY * 16
  .endif
.elseif ax == KEY_UP1
		dec	bh
		sub	dx, 16
  .if bh < FONT_Y
		mov	bh, FONT_Y + FONT_CY - 1
		add	dx, FONT_CY * 16
  .endif
.endif
		jmp	char_map2
char_map9:
		bios1	CURSOR_DISPLAY, FALSE
		pop	ds
		ret
char_map	endp

; DX : code
; DI : fontbuff
char_zoom	proc
		push	di
		mov	cx, 32 / 2
		clr	ax
	rep	stosw
		mov	cx, dx
		pop	dx
		bios	TEXT_GET_FONTDATA
IFDEF ROTATE
		pusha
		call	rotate_font
		popa
ENDIF
		push	dx		; dx = fontbuff
.if ax == 0
		push	di

		mov	si, dx
		mov	cx, 8
  .repeat
		lodsb
		push	cx
		call	zoom_x
		pop	cx
		mov	[si-1], bh
		mov	[si+7], bl
  .untilcxz
		mov	si, dx
		call	zoom_y
		mov	si, dx
		add	si, 8
		call	zoom_y

		pop	di
.endif

		movlh	bx, ZOOM_X, ZOOM_Y
		movlh	cx, 2, 2
		add	dx, 32
		bios1	SCREEN_GET_CHAR, 1

		mov	bx, [di]	; di = fontbuf+32
		and	bx, 01FFh
		mov	cx, 2
		pop	dx
		bios	FONT_SET_MONODATA

		mov	bx, [di+4]
		and	bx, 01FFh
		add	dx, 16
		bios	FONT_SET_MONODATA
		ret
char_zoom	endp

zoom_y		proc
		add	si, 7
		mov	di, si
		add	di, 16
		mov	cx, 8
.repeat
		mov	al, [si]
		dec	si
		mov	[di], al
		mov	[di-1], al
		dec	di
		dec	di
		cmp	cx, 5
.if zero?
		sub	di, 8
.endif
.untilcxz
		ret
zoom_y		endp

zoom_x		proc
		clr	bx
		mov	cx, 8
.repeat
		shr	al, 1
		rcr	bx, 1
		sar	bx, 1
.untilcxz
		ret
zoom_x		endp

IFDEF ROTATE
; DX : font buffer
rotate_font	proc
		sub	sp, 8
		mov	di, sp
		mov	cl, 1
.repeat
		mov	si, dx
		mov	bx, 8
		clr	ah
		even
  .repeat
		lodsb
		shl	al, cl
		rcr	ah, 1
		dec	bx
  .until zero?
		mov	[di], ah
		inc	di
		inc	cx
.until cl > 8
		mov	si, sp
		mov	di, dx
		mov	cx, 4
	rep	movsw
		add	sp, 8
		ret
rotate_font	endp
ENDIF

		end
