/*
 *  Dialog manager definitions
 *	issued: 2000/4/6
 *	author: c.mos@zob.ne.jp
 */

#ifndef _DIALOG_H_
#define _DIALOG_H_

#include "gui.h"

#define MB_OK				0x0001
#define MB_YES				0x0002
#define MB_NO				0x0004
#define MB_CANCEL			0x0008

#define MB_ICONERROR		0x0100
#define MB_ICONQUESTION		0x0200
#define MB_ICONEXCLAMATION	0x0300
#define MB_ICONINFOMATION	0x0400
#define MB_ICON_COUNT 4

#define MB_DEFBUTTON2		0x1000
#define MB_DEFBUTTON3		0x2000
#define MB_DEFBUTTON4		0x3000

#define MB_TYPEMASK			0x00FF
#define MB_ICONMASK			0x0F00
#define MB_ICONSHIFT		8
#define MB_DEFBUTTONMASK	0x3000
#define MB_DEFBUTTONSHIFT	12

enum {
	IDOK, IDYES, IDNO, IDCANCEL, IDCOUNT
};

enum {
	CTR_NULL, CTR_TEXT, CTR_VALUE, CTR_ICON, CTR_PUSHBUTTON, CTR_PROGRESSBAR, CTR_HLINE
};

enum {
	ICON_ERROR,
	ICON_QUESTION,
	ICON_EXCLAMATION,
	ICON_INFOMATION,
	ICON_COMM,
	ICON_COUNT,
};

#define CTF_REDRAW 1
#define CTF_HIDE 2
#define CTF_OWNER_DRAW 4

typedef struct {
	BYTE type;
	BYTE flags;
	union {
		void *p;
		int  n;
	    void *(*fp)(int x, int y, int ctri, void *param);
	} data;
	int value;
	int range;
	Rect wnd;
} Control;

typedef struct {
	char *caption;
	Control *controls;
	WORD type;
	int	 ctrl_count;
	int	 ctrl_select;
	void *param;
	Rect wnd;
} Dialog;

int message_box(char *text, char *caption, WORD type);

void open_dialog(Dialog *dlg);
void close_dialog(Dialog *dlg);
void redraw_dialog(Dialog *dlg, BOOL all);

#endif _DIALOG_H_
